#-----------------------------------------------------------------
# Preference Window
#-----------------------------------------------------------------

proc preferenceWindow {} { global s c w l
    if [winfo exists .preference] { return }
    toplevel .preference
    wm title .preference "TkScan: Preference"

    # Driver and Device
    set pd .preference.device
    frame $pd -bd 1 -relief groove
    frame $pd.u
    frame $pd.d
    pack $pd.u $pd.d -side top -fill x
    label $pd.u.l -text Command -width 15 -anchor e
    entry $pd.u.d -textvariable s(command) \
                     -width 20 -font $l(f1) -fg $l(c1) -relief sunken
    pack $pd.u.l $pd.u.d -side left
    label $pd.d.l -text Device -width 15 -anchor e
    entry $pd.d.d -textvariable s(device) \
                     -width 20 -font $l(f1) -fg $l(c1) -relief sunken
    pack $pd.d.l $pd.d.d -side left

    # Preview
    set pp .preference.preview
    frame $pp -bd 1 -relief groove
    frame $pp.m
    pack $pp.m -side top -fill x
    label $pp.m.p -text "Preview Mode" -width 15 -anchor e
    menubutton $pp.m.m -menu $pp.m.m.m -width 10 -relief ridge -fg $l(c1)
    set w(premodebutton) $pp.m.m
    pack $pp.m.p $pp.m.m -side left
    menu $pp.m.m.m -tearoff false
    foreach i $s(modeList) { set modename [lindex $i 0]
        $pp.m.m.m add command -label $modename \
                              -command "setpremode $modename"
    }
        $pp.m.m.m add command -label Current \
                              -command "setpremode Current"
    frame $pp.r
    pack $pp.r -side top -fill x
    label $pp.r.l -text "Resolution" -width 15 -padx 0 -anchor e
    set s(prepreresolution) $s(preresolution)
    entryscale $pp.r s(prepreresolution) {} $s(preresolutionRange) 60
    button $pp.r.b -text Apply -width 5 -padx 0 \
              -command {setpreresolution $s(prepreresolution)}
    pack $pp.r.l $pp.r.e $pp.r.s $pp.r.b -side left
    setpremode $s(premode)

    # Gamma support
    set pg .preference.gamma
    frame $pg -bd 1 -relief groove
    label $pg.l -text "Gamma Support" -width 15 -anchor e
    radiobutton $pg.1 -text Driver -variable s(gamma_support) -value 0
    radiobutton $pg.2 -text External -variable s(gamma_support) -value 1
    pack $pg.l $pg.1 $pg.2 -side left

    # Image Editor
    set ie .preference.ie
    frame $ie -bd 1 -relief groove
    label $ie.l -text "Image Editor" -width 15 -anchor e
    menubutton $ie.mb -menu $ie.mb.m -text $c(ImageEditor) \
                      -width 12 -relief ridge -fg $l(c1)
    checkbutton $ie.cb -text SW -variable c(ImageEditorWinmode)
    pack $ie.l $ie.mb $ie.cb -side left
    menu $ie.mb.m -tearoff false
    foreach i $c(ImageEditorList) { set iename [lindex $i 0]
        $ie.mb.m add command -label $iename -command "
            $ie.mb configure -text $iename
            set c(ImageEditor) $iename
        "
    }

    # Image and Fax viewer
    set pv .preference.viewer
    frame $pv -bd 1 -relief groove
    frame $pv.1
    frame $pv.2
    pack  $pv.1 $pv.2 -side top
    label $pv.1.l -text "Image Viewer" -width 15 -anchor e
    entry $pv.1.e -textvariable file(viewer) -width 20 -fg $l(c1) -font $l(f1)
    pack  $pv.1.l $pv.1.e -side left
    label $pv.2.l -text "Fax Viewer" -width 15 -anchor e
    entry $pv.2.e -textvariable fax(viewer)  -width 20 -fg $l(c1) -font $l(f1)
    pack  $pv.2.l $pv.2.e -side left

    # Printer paper
    set pa .preference.paper
    frame $pa -bd 1 -relief groove
    label $pa.l -text "Printer Paper" -width 15 -anchor e
    radiobutton $pa.1 -text A4 -variable pr(paper) -value A4
    radiobutton $pa.2 -text Letter -variable pr(paper) -value Letter
    pack $pa.l $pa.1 $pa.2 -side left

    # Temporary directory
    set pt .preference.tmpdir
    frame $pt -bd 1 -relief groove
    frame $pt.u
    frame $pt.d
    pack $pt.u $pt.d -side top -fill x
    label $pt.u.1 -text "TMP Directory" -width 15 -anchor e
    checkbutton $pt.u.2 -text "Clear when Exit" -variable c(tmpdirclear)
    pack $pt.u.1 $pt.u.2 -side left -fill x
    label $pt.d.1 -text "" -width 15 -anchor e
    button $pt.d.2 -text "Clear Now" -width 12 \
           -command clear_tkscandir
    pack $pt.d.1 $pt.d.2 -side left -fill x

    # Packing
    pack $pd $pp $pg $ie $pv $pa $pt -side top -fill x

    # Buttons
    set pb .preference.button
    frame $pb
    pack $pb -side bottom -expand yes -fill x
    button $pb.h -text Done -pady 0 -command { destroy .preference }
    pack $pb.h -side left -expand yes -fill x
}

